﻿using Microsoft.ServiceBus.Messaging;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Messages
{
    public class ChunkedMessageBuilder
    {

        public Stream ReconstructMessageBody(BrokeredMessage[] messages)
        {
            var messageBodyStream = new MemoryStream();
            var streamWriter = new StreamWriter(messageBodyStream);
            StreamReader streamReader = null;

            foreach(var message in messages)
            {
                streamReader = new StreamReader(message.GetBody<Stream>());
                var text = streamReader.ReadToEnd();
                streamWriter.Write(text);
                streamWriter.Flush();
                messageBodyStream.Flush();
            }
            messageBodyStream.Seek(0, SeekOrigin.Begin);
            return messageBodyStream;
        }
    }
}
