﻿using Microsoft.ServiceBus.Messaging;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.ServiceBus;

namespace Sample.Receiver.SB.AMQP
{
    class Program
    {
        private static MessagingFactory _messagingFactory;

        static void Main(string[] args)
        {
            Console.ForegroundColor = ConsoleColor.Green;
            Console.WriteLine("Receiver 2 starting");

            const string ReceivePath = "myTopic/Subscriptions/receiver2";

            ServiceBusEnvironment.SystemConnectivity.Mode = ConnectivityMode.Http;
            var connectionString = ConfigurationManager.ConnectionStrings["Test"];
            _messagingFactory = MessagingFactory.CreateFromConnectionString(connectionString.ConnectionString);

            var receiver = _messagingFactory.CreateMessageReceiver(ReceivePath, ReceiveMode.PeekLock);

            #region variables
            var responseQueue = string.Empty;
            var sessionId = string.Empty;
            var correlationId = string.Empty;
            #endregion

            while (true)
            {
                Console.WriteLine("Waiting for new message");

                var message = receiver.Receive();
                if (message == null)
                    continue;

                Console.WriteLine("Received Message");

                var messageBtyes = message.GetBody<byte[]>();
                var messageBodyStream = new MemoryStream(messageBtyes);                
                var myBigObject = Messages.SerializationHelper.Deserialize<Messages.VeryBigDataType>(messageBodyStream);                
                message.Complete();

                Console.WriteLine(string.Format("Request Message is = {0}", myBigObject.BigValue));
                Console.WriteLine("");                
            }

            Console.ReadLine();
        }        
    }
}
