﻿using Microsoft.ServiceBus.Messaging;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Transactions;
using Microsoft.ServiceBus;
using System.Net;
using System.Security.Cryptography;
using System.Web;
using System.Globalization;
using Messages;
using System.Runtime.Serialization;

namespace Sample.Client.SB.AMQP
{
    class Program
    {
        const string RequestTopic = "myTopic";        
        private static MessagingFactory _messagingFactory;

        static void Main(string[] args)
        {
            Console.ForegroundColor = ConsoleColor.White;
            Console.WriteLine("Press a key to start");
            Console.ReadLine();

            var connectionString = ConfigurationManager.ConnectionStrings["Test"];
            _messagingFactory = MessagingFactory.CreateFromConnectionString(connectionString.ConnectionString);

            while (true)
            {
                var stringBuilder = new StringBuilder();
                stringBuilder.Append("Hello world");

                var messageBody = new Messages.VeryBigDataType();
                messageBody.BigValue = stringBuilder.ToString();

                SendMessage(messageBody);
                Console.WriteLine("Message sent");
                Console.WriteLine();
                Console.WriteLine();
                
                Console.WriteLine("Press a key to send another message");
                Console.ReadLine();
            }

            Console.ReadLine();            
        }

        public static void SendMessage(Messages.VeryBigDataType data)
        {           
            var requestData = Messages.SerializationHelper.Serialize(data);            
            var serviceBusMessage = new BrokeredMessage(requestData.ToArray());                        
            serviceBusMessage.ContentType = "application/json";

            var sender = _messagingFactory.CreateMessageSender(RequestTopic);
            sender.Send(serviceBusMessage);

            Console.Write(string.Format("response message sent"));
            Console.WriteLine();
        }        
        
    }
}
